"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.doTelemetry = doTelemetry;
var _telemetry = require("@storybook/telemetry");
var _metadata = require("./metadata");
var _summarizeIndex = require("./summarizeIndex");
var _router = require("./router");
var _versionStatus = require("./versionStatus");
async function doTelemetry(core, initializedStoryIndexGenerator, options) {
  if (!(core !== null && core !== void 0 && core.disableTelemetry)) {
    initializedStoryIndexGenerator.then(async function (generator) {
      var storyIndex = await (generator === null || generator === void 0 ? void 0 : generator.getIndex());
      var versionCheck = options.versionCheck,
        versionUpdates = options.versionUpdates;
      var payload = {
        precedingUpgrade: await (0, _telemetry.getPrecedingUpgrade)()
      };
      if (storyIndex) {
        Object.assign(payload, {
          versionStatus: versionUpdates ? (0, _versionStatus.versionStatus)(versionCheck) : 'disabled',
          storyIndex: (0, _summarizeIndex.summarizeIndex)(storyIndex)
        });
      }
      (0, _telemetry.telemetry)('dev', payload, {
        configDir: options.configDir
      });
    });
  }
  if (!(core !== null && core !== void 0 && core.disableProjectJson)) {
    (0, _metadata.useStorybookMetadata)(_router.router, options.configDir);
  }
}