"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getStoryIndexGenerator = getStoryIndexGenerator;
var _coreCommon = require("@storybook/core-common");
var _storiesJson = require("./stories-json");
var _StoryIndexGenerator = require("./StoryIndexGenerator");
var _router = require("./router");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
async function getStoryIndexGenerator(features, options, serverChannel) {
  var initializedStoryIndexGenerator = Promise.resolve(undefined);
  if (features !== null && features !== void 0 && features.buildStoriesJson || features !== null && features !== void 0 && features.storyStoreV7) {
    var workingDir = process.cwd();
    var directories = {
      configDir: options.configDir,
      workingDir: workingDir
    };
    var stories = options.presets.apply('stories');
    var storyIndexers = options.presets.apply('storyIndexers', []);
    var docsOptions = options.presets.apply('docs', {});
    var normalizedStories = (0, _coreCommon.normalizeStories)(await stories, directories);
    var generator = new _StoryIndexGenerator.StoryIndexGenerator(normalizedStories, _objectSpread(_objectSpread({}, directories), {}, {
      storyIndexers: await storyIndexers,
      docs: await docsOptions,
      workingDir: workingDir,
      storiesV2Compatibility: !(features !== null && features !== void 0 && features.breakingChangesV7) && !(features !== null && features !== void 0 && features.storyStoreV7),
      storyStoreV7: features === null || features === void 0 ? void 0 : features.storyStoreV7
    }));
    initializedStoryIndexGenerator = generator.initialize().then(function () {
      return generator;
    });
    (0, _storiesJson.useStoriesJson)({
      router: _router.router,
      initializedStoryIndexGenerator: initializedStoryIndexGenerator,
      normalizedStories: normalizedStories,
      serverChannel: serverChannel,
      workingDir: workingDir
    });
  }
  return initializedStoryIndexGenerator;
}