"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getMiddleware = getMiddleware;
var _path = _interopRequireDefault(require("path"));
var _fs = _interopRequireDefault(require("fs"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var fileExists = function (basename) {
  return ['.js', '.cjs'].reduce(function (found, ext) {
    var filename = `${basename}${ext}`;
    return !found && _fs.default.existsSync(filename) ? filename : found;
  }, '');
};
function getMiddleware(configDir) {
  var middlewarePath = fileExists(_path.default.resolve(configDir, 'middleware'));
  if (middlewarePath) {
    // eslint-disable-next-line global-require, import/no-dynamic-require
    var middlewareModule = require(middlewarePath);
    // eslint-disable-next-line no-underscore-dangle
    if (middlewareModule.__esModule) {
      middlewareModule = middlewareModule.default;
    }
    return middlewareModule;
  }
  return function () {};
}