import { telemetry, getPrecedingUpgrade } from '@storybook/telemetry';
import { useStorybookMetadata } from './metadata';
import { summarizeIndex } from './summarizeIndex';
import { router } from './router';
import { versionStatus } from './versionStatus';
export async function doTelemetry(core, initializedStoryIndexGenerator, options) {
  if (!(core !== null && core !== void 0 && core.disableTelemetry)) {
    initializedStoryIndexGenerator.then(async function (generator) {
      var storyIndex = await (generator === null || generator === void 0 ? void 0 : generator.getIndex());
      var versionCheck = options.versionCheck,
        versionUpdates = options.versionUpdates;
      var payload = {
        precedingUpgrade: await getPrecedingUpgrade()
      };
      if (storyIndex) {
        Object.assign(payload, {
          versionStatus: versionUpdates ? versionStatus(versionCheck) : 'disabled',
          storyIndex: summarizeIndex(storyIndex)
        });
      }
      telemetry('dev', payload, {
        configDir: options.configDir
      });
    });
  }
  if (!(core !== null && core !== void 0 && core.disableProjectJson)) {
    useStorybookMetadata(router, options.configDir);
  }
}