import path from 'path';
import fs from 'fs';
var fileExists = function (basename) {
  return ['.js', '.cjs'].reduce(function (found, ext) {
    var filename = `${basename}${ext}`;
    return !found && fs.existsSync(filename) ? filename : found;
  }, '');
};
export function getMiddleware(configDir) {
  var middlewarePath = fileExists(path.resolve(configDir, 'middleware'));
  if (middlewarePath) {
    // eslint-disable-next-line global-require, import/no-dynamic-require
    var middlewareModule = require(middlewarePath);
    // eslint-disable-next-line no-underscore-dangle
    if (middlewareModule.__esModule) {
      middlewareModule = middlewareModule.default;
    }
    return middlewareModule;
  }
  return function () {};
}