export function summarizeIndex(storyIndex) {
  var storyCount = 0;
  var autodocsCount = 0;
  var storiesMdxCount = 0;
  var mdxCount = 0;
  Object.values(storyIndex.entries).forEach(function (entry) {
    if (entry.type === 'story') {
      storyCount += 1;
    } else if (entry.type === 'docs') {
      if (entry.standalone) {
        mdxCount += 1;
      } else if (entry.importPath.endsWith('.mdx')) {
        storiesMdxCount += 1;
      } else {
        autodocsCount += 1;
      }
    }
  });
  return {
    storyCount: storyCount,
    autodocsCount: autodocsCount,
    storiesMdxCount: storiesMdxCount,
    mdxCount: mdxCount,
    version: storyIndex.v
  };
}